diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
new file mode 100644
index 000000000..df83b1868
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
@@ -0,0 +1,270 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
+import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.Global;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
+
+import static net.minecraft.core.util.helper.Utils.floor10;
+
+public class HudComponentInfoOverlay
+    extends HudComponentMovable
+{
+    public HudComponentInfoOverlay(String key, Layout layout) {
+        super(key, 130, 112, layout);
+    }
+
+    @Override
+    public boolean isVisible() {
+        return mc.gameSettings.immersiveMode.drawOverlays() && !mc.gameSettings.showDebugScreen.value;
+    }
+
+    private void drawString(String string, int x, int y, int argb, boolean rightAligned) {
+        int xOffset = -2;
+        if (rightAligned) {
+            xOffset = mc.font.stringWidth(string) + 2 - this.getXSize();
+        }
+
+        mc.font.render(Tessellator.instance, string, x - xOffset, y).setShadow().setColor(argb).call();
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        boolean rightAligned = false;
+        if (this.getLayout() instanceof LayoutAbsolute) {
+            final LayoutAbsolute layout = (LayoutAbsolute) this.getLayout();
+            final ComponentAnchor anchor = layout.getAnchor();
+            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
+                rightAligned = true;
+            }
+        } else if (this.getLayout() instanceof LayoutSnap) {
+            final LayoutSnap layout = (LayoutSnap) this.getLayout();
+            final ComponentAnchor anchor = layout.getAnchor();
+            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
+                rightAligned = true;
+            }
+        }
+
+        boolean clock = false;
+        boolean compass = false;
+        boolean rotaryCalendar = false;
+
+        if (mc.thePlayer.getGamemode() == Gamemode.creative)
+        {
+            clock = true;
+            compass = true;
+            rotaryCalendar = true;
+        }
+        else
+        {
+            for (int iinv = 0; iinv < mc.thePlayer.inventory.getContainerSize(); iinv++)
+            {
+                ItemStack item = mc.thePlayer.inventory.getItem(iinv);
+                if (item != null)
+                {
+                    if (item.itemID == Items.TOOL_CLOCK.id)
+                    {
+                        clock = true;
+                    }
+                    if (item.itemID == Items.TOOL_COMPASS.id)
+                    {
+                        compass = true;
+                    }
+                    if (item.itemID == Items.TOOL_CALENDAR.id)
+                    {
+                        rotaryCalendar = true;
+                    }
+                }
+            }
+        }
+
+        int tsp = 2;
+        int line = 0;
+        int lineHeight = 10;
+
+        if (mc.gameSettings.versionInOverlay.value) {
+            int color;
+            if (mc.gameSettings.overlayMode.value == 2)
+            {
+                color = 0xFFFFFF60;
+            } else {
+                color = 0xFFFFFFFF;
+            }
+            drawString("Better than Adventure! " + TextFormatting.WHITE + Global.VERSION, x, y + tsp + lineHeight * line++, color, rightAligned);
+        }
+        if (mc.gameSettings.fpsInOverlay.value)
+        {
+            drawString(mc.debugFPS, x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+        }
+        if (compass)
+        {
+            if (mc.gameSettings.overlayShowCoords.value)
+            {
+                if (mc.gameSettings.overlayMode.value == 0)
+                {
+                    drawString("x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                }
+                if (mc.gameSettings.overlayMode.value == 1)
+                {
+                    drawString( "x: " + floor10(mc.thePlayer.x), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                    drawString( "y: " + floor10(mc.thePlayer.y), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                    drawString( "z: " + floor10(mc.thePlayer.z), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                }
+                if (mc.gameSettings.overlayMode.value == 2)
+                {
+                    drawString("x: " + floor10(mc.thePlayer.x), x, y + tsp + lineHeight * line++, 0xFFFF8080, rightAligned);
+                    drawString("y: " + floor10(mc.thePlayer.y), x, y + tsp + lineHeight * line++, 0xFF80FF80, rightAligned);
+                    drawString("z: " + floor10(mc.thePlayer.z), x, y + tsp + lineHeight * line++, 0xFF8080FF, rightAligned);
+                }
+            }
+            if (mc.gameSettings.overlayShowDirection.value)
+            {
+                drawString(I18n.getInstance().translateKey(HudIngame.getFacingDirection(mc.thePlayer).getTranslationKey()), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+            }
+        }
+        if (clock)
+        {
+            if (mc.gameSettings.overlayShowTime.value)
+            {
+                if (mc.gameSettings.overlayMode.value == 0)
+                {
+                    drawString(String.format("%s %s %d", HudIngame.getTimeString(mc), I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                }
+                if (mc.gameSettings.overlayMode.value > 0)
+                {
+                    drawString(HudIngame.getTimeString(mc), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                    drawString(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                }
+            }
+        }
+        if (rotaryCalendar)
+        {
+            if (mc.gameSettings.overlayShowSeason.value)
+            {
+                Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
+                if (season != null)
+                {
+                    drawString(season.getTranslatedName(), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF, rightAligned);
+                }
+            }
+            if (mc.gameSettings.overlayShowWeather.value)
+            {
+                Weather weather = mc.currentWorld.getCurrentWeather();
+                if (weather != null && weather != mc.currentWorld.worldType.getDefaultWeather())
+                {
+                    drawString(I18n.getInstance().translateKey(weather.getNameLanguageKey()), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, rightAligned);
+                }
+            }
+            if(mc.gameSettings.overlayShowBiome.value)
+            {
+                int blockX = MathHelper.floor(mc.thePlayer.x);
+                int blockY = MathHelper.floor(mc.thePlayer.y);
+                int blockZ = MathHelper.floor(mc.thePlayer.z);
+                String key = mc.currentWorld.getBlockBiome(blockX, blockY, blockZ).translationKey;
+                drawString(I18n.getInstance().translateKey(key), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+            }
+        }
+    }
+
+    @Override
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        boolean rightAligned = false;
+        if (layout instanceof LayoutAbsolute) {
+            final LayoutAbsolute l = (LayoutAbsolute) this.getLayout();
+            final ComponentAnchor anchor = l.getAnchor();
+            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
+                rightAligned = true;
+            }
+        } else if (layout instanceof LayoutSnap) {
+            final LayoutSnap l = (LayoutSnap) this.getLayout();
+            final ComponentAnchor anchor = l.getAnchor();
+            if (anchor == ComponentAnchor.TOP_RIGHT || anchor == ComponentAnchor.CENTER_RIGHT || anchor == ComponentAnchor.BOTTOM_RIGHT) {
+                rightAligned = true;
+            }
+        }
+
+        int tsp = 2;
+        int line = 0;
+        int lineHeight = 10;
+
+        { // FPS
+            drawString("60 fps", x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+        }
+        { // Compass
+            {
+                final double px = 372.853;
+                final double py = 64.355;
+                final double pz = 38472.333;
+
+                if (mc.gameSettings.overlayMode.value == 0)
+                {
+                    drawString("x: " + floor10(px) + " y: " + floor10(py) + " z: " + floor10(pz), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                }
+                if (mc.gameSettings.overlayMode.value == 1)
+                {
+                    drawString("x: " + floor10(px), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                    drawString("y: " + floor10(py), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                    drawString("z: " + floor10(pz), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+                }
+                if (mc.gameSettings.overlayMode.value == 2)
+                {
+                    drawString("x: " + floor10(px), x, y + tsp + lineHeight * line++, 0xFFFF8080, rightAligned);
+                    drawString("y: " + floor10(py), x, y + tsp + lineHeight * line++, 0xFF80FF80, rightAligned);
+                    drawString("z: " + floor10(pz), x, y + tsp + lineHeight * line++, 0xFF8080FF, rightAligned);
+                }
+            }
+            {
+                drawString(I18n.getInstance().translateKey(Direction.NORTH.getTranslationKey()), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+            }
+        }
+        {
+            {
+                if (mc.gameSettings.overlayMode.value == 0)
+                {
+                    drawString(String.format("%s %s %d", "8:32", I18n.getInstance().translateKey("unit.day"), 500), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                }
+                if (mc.gameSettings.overlayMode.value > 0)
+                {
+                    drawString("8:32", x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                    drawString(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), 500), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFFFF80 : 0xFFFFFFFF, rightAligned);
+                }
+            }
+        }
+        {
+            {
+                Season season = Seasons.OVERWORLD_SUMMER;
+                drawString(season.getTranslatedName(), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF, rightAligned);
+            }
+            {
+                Weather weather = Weathers.OVERWORLD_FOG;
+                drawString(I18n.getInstance().translateKey(weather.getNameLanguageKey()), x, y + tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, rightAligned);
+            }
+            {
+                String key = Biomes.OVERWORLD_GRASSLANDS.translationKey;
+                drawString(I18n.getInstance().translateKey(key), x, y + tsp + lineHeight * line++, 0xFFFFFFFF, rightAligned);
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
index 42d081191..d25b23c9f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
@@ -64,17 +64,17 @@ public class HudComponentLog extends HudComponentMovable {
     }
 
     @Override
-    public boolean isEnabled(final @NotNull Minecraft mc) {
+    public boolean isEnabled() {
         return mc.gameSettings.developerMode.value;
     }
 
     @Override
-    public boolean isVisible(final @NotNull Minecraft mc) {
+    public boolean isVisible() {
         return mc.gameSettings.developerMode.value;
     }
 
     @Override
-    public void render(final @NotNull Minecraft mc, final @NotNull HudIngame hud, final int xSizeScreen, final int ySizeScreen, final float partialTick) {
+    public void render(final @NotNull HudIngame hud, final int xSizeScreen, final int ySizeScreen, final float partialTick) {
         if (!this.callbackAdded) {
             LogMessageReceiver.addCallback((message) -> {
                 if (message.getMessage().startsWith("[CHAT] ")) return;
@@ -108,8 +108,8 @@ public class HudComponentLog extends HudComponentMovable {
             callbackAdded = true;
         }
 
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         // Remove dead entries
         for (int i = 0; i < this.logEntries.size(); i++) {
@@ -137,9 +137,9 @@ public class HudComponentLog extends HudComponentMovable {
     }
 
     @Override
-    public void renderPreview(final @NotNull Minecraft mc, final @NotNull Gui gui, final @NotNull Layout layout, final int xSizeScreen, final int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(final @NotNull Gui gui, final @NotNull Layout layout, final int xSizeScreen, final int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         final @NotNull String @NotNull[] lines = {
             this.preludes.get(LogMessage.Level.DEBUG) + "This is a debug line!",
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
index e100af5b8..87e372230 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentOxygenBar.java
@@ -20,14 +20,14 @@ public class HudComponentOxygenBar
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.isUnderLiquid(Material.water);
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
@@ -49,9 +49,9 @@ public class HudComponentOxygenBar
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
index 654d26164..a34afcf59 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
@@ -16,18 +16,18 @@ public class HudComponentRotationLock
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.thePlayer.rotationLock != null && mc.thePlayer.rotationLock != Direction.NONE && mc.gameSettings.immersiveMode.drawOverlays();
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
         GL11.glDisable(GL11.GL_BLEND);
 
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         String prefix = mc.gameSettings.rotationOverlayMode.value % 2 == 1 ? "arrow" : "cube";
 
@@ -86,9 +86,9 @@ public class HudComponentRotationLock
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
similarity index 81%
rename from game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
rename to game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
index be8a27ca2..b9dbb41fd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentSubtitles.java
@@ -17,36 +17,41 @@ import static org.lwjgl.opengl.GL11.GL_BLEND;
 import static org.lwjgl.opengl.GL11.GL_ONE_MINUS_SRC_ALPHA;
 import static org.lwjgl.opengl.GL11.GL_SRC_ALPHA;
 
-public class HubComponentSubtitles extends HudComponentMovable {
-    public HubComponentSubtitles(String key, int xSize, int ySize, Layout layout) {
+public class HudComponentSubtitles extends HudComponentMovable {
+    public HudComponentSubtitles(String key, int xSize, int ySize, Layout layout) {
         super(key, xSize, ySize, layout);
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.gameSettings.immersiveMode.drawOverlays() && mc.gameSettings.subtitles.value;
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        drawChat(mc, hud, new ArrayList<>(mc.subtitleTracker.entryMap.values()), xSizeScreen, ySizeScreen, partialTick);
+    public boolean isEnabled() {
+        return mc.gameSettings.subtitles.value;
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        drawChat(hud, new ArrayList<>(mc.subtitleTracker.entryMap.values()), xSizeScreen, ySizeScreen, partialTick);
+    }
+
+    @Override
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
         List<SubtitleTracker.SubtitleEntry> example = new ArrayList<>();
         example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("mob.wolf.whine"), 0, 0, 0));
         example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("random.drr"), 0, 0, 0));
         example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("random.bow"), 0, 0, 0));
-        drawChat(mc, gui, example, xSizeScreen, ySizeScreen, 0);
+        drawChat(gui, example, xSizeScreen, ySizeScreen, 0);
     }
 
-    public void drawChat(Minecraft mc, Gui gui, List<SubtitleTracker.SubtitleEntry> subtitleEntries, int xSizeScreen, int ySizeScreen, float partialTick)
+    public void drawChat(Gui gui, List<SubtitleTracker.SubtitleEntry> subtitleEntries, int xSizeScreen, int ySizeScreen, float partialTick)
     {
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
-        int width = getXSize(mc);
-        int height = getYSize(mc);
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+        int width = getXSize();
+        int height = getYSize();
         int xRight = x + width;
         int yBottom = y + height;
         int messagesToShow = height/10;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 4573a52df..8dc127e0c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -65,6 +65,9 @@ public class HudComponents {
     public static final HudComponent OXYGEN_BAR = register(new HudComponentOxygenBar("oxygen_bar", new LayoutSnap(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent FIRE_BAR = register(new HudComponentFireBar("fire_bar", new LayoutSnap(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent ROTATION_LOCK = register(new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
-    public static final HudComponent SUBTITLES = register(new HubComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT)));
+    public static final HudComponent SUBTITLES = register(new HudComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT)));
     public static final HudComponent LOG = register(new HudComponentLog("log", new LayoutAbsolute(1.0f, 0.0f, ComponentAnchor.TOP_RIGHT)));
+    public static final HudComponent ARMOR_DURABILITY = register(new HudComponentArmorDurability("armor_durability", new LayoutAbsolute(0.0f, 1.0f, ComponentAnchor.BOTTOM_LEFT)));
+    public static final HudComponent HELD_ITEM_COUNT = register(new HudComponentHeldItemCount("held_item_count", new LayoutSnap(HOTBAR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
+    public static final HudComponent INFO_OVERLAY = register(new HudComponentInfoOverlay("info_overlay", new LayoutAbsolute(0.0f, 0.0f, ComponentAnchor.TOP_LEFT)));
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/Layout.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/Layout.java
index d040060ee..9fe05c4e7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/Layout.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/Layout.java
@@ -4,8 +4,10 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.hud.component.HudComponent;
 
 public abstract class Layout {
-    public abstract int getComponentX(Minecraft mc, HudComponent component, int xSizeScreen);
-    public abstract int getComponentY(Minecraft mc, HudComponent component, int ySizeScreen);
+    protected static final Minecraft mc = Minecraft.getMinecraft();
+
+    public abstract int getComponentX(HudComponent component, int xSizeScreen);
+    public abstract int getComponentY(HudComponent component, int ySizeScreen);
     public abstract Layout copy();
     public abstract String toSettingsString();
     public abstract void fromSettingsString(String settings);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
index 4ab7094a6..95b769d4a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
@@ -41,13 +41,13 @@ public class LayoutAbsolute
     }
 
     @Override
-    public int getComponentX(Minecraft mc, HudComponent component, int xSizeScreen) {
+    public int getComponentX(HudComponent component, int xSizeScreen) {
         int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
         return (int) (xPosition * xSizeScreen) - component.getAnchorX(anchor) + sp;
     }
 
     @Override
-    public int getComponentY(Minecraft mc, HudComponent component, int ySizeScreen) {
+    public int getComponentY(HudComponent component, int ySizeScreen) {
         int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
         return (int) (yPosition * ySizeScreen) - component.getAnchorY(anchor) + sp;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
index d42c7cb01..034cdcbcf 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutSnap.java
@@ -42,21 +42,21 @@ public class LayoutSnap
     }
 
     @Override
-    public int getComponentX(Minecraft mc, HudComponent component, int xSizeScreen) {
+    public int getComponentX(HudComponent component, int xSizeScreen) {
         if (parent == null) {
             int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
             return (int) (xSizeScreen * parentAnchor.xPosition) - component.getAnchorX(anchor) + sp;
         }
-        return parent.getLayout().getComponentX(mc, parent, xSizeScreen) - component.getAnchorX(anchor) + parent.getAnchorX(parentAnchor);
+        return parent.getLayout().getComponentX(parent, xSizeScreen) - component.getAnchorX(anchor) + parent.getAnchorX(parentAnchor);
     }
 
     @Override
-    public int getComponentY(Minecraft mc, HudComponent component, int ySizeScreen) {
+    public int getComponentY( HudComponent component, int ySizeScreen) {
         if (parent == null) {
             int sp = (int) (mc.gameSettings.screenPadding.value * mc.resolution.getScaledHeightScreenCoords() / 8);
             return (int) (ySizeScreen * parentAnchor.yPosition) - component.getAnchorY(anchor) + sp;
         }
-        return parent.getLayout().getComponentY(mc, parent, ySizeScreen) - component.getAnchorY(anchor) + parent.getAnchorY(parentAnchor);
+        return parent.getLayout().getComponentY(parent, ySizeScreen) - component.getAnchorY(anchor) + parent.getAnchorY(parentAnchor);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
index 6054a0186..865e141e0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
@@ -45,7 +45,7 @@ public class ViewerCategoryEntity extends ModelViewerCategory<ModelViewerCategor
         createEntries();
     }
     public void createEntries(){
-        for (NamespaceID id : EntityDispatcher.idToClassMap.keySet()){
+        for (NamespaceID id : EntityDispatcher.getInstance().idToEntryMap.keySet()){
             try{
                 addEntry(new EntityEntryDispatcher(id));
             } catch (Exception ignore){}
@@ -84,7 +84,7 @@ public class ViewerCategoryEntity extends ModelViewerCategory<ModelViewerCategor
     public String getCurrentDisplayInfo(I18n translator) {
         String title = "None";
         if (displayEntity != null){
-            title = EntityDispatcher.idForClass(displayEntity.getClass()).toString();
+            title = String.valueOf(displayEntity.getDispatcherId());
         }
         return translator.translateKeyAndFormat("model.category.entity.info", title);
     }
